****************************************************************************
****************************************************************************
**                                                                        **
**   Phoenix for Fargo II : Enemy Destruction Routines                    **
**                                                                        **
**   Copyright 1997-2000 by Patrick Davidson.  All Rights Reserved.       **
**                                                                        **
**   This file was last updated May 7, 2000                               **
**                                                                        **
**   For complete copyright information and contact addresses, refer to   **
**   the main source file "PHOENIX.ASM"                                   **
**                                                                        **
****************************************************************************
****************************************************************************

********************************************** ENEMY DESCTRUCTION ROUTINES
*
* This file consists of enemy destruction routines.  These routines are
* called when an enemy is destroyed, with A4 pointing to the address of the
* enemy structure.  The routine should "destroy" the enemy by changing its
* type to an explosion.  Also, special actions are possible, such as making
* the enemy become another enemy type, for enemies which must be destroyed
* in stages.  Each routine should preserve D3, D4, A3, and A4.
*
* The address of the enemy destruction routine (as a word offset from the
* label Enemy_Collisions) is stored in the e_dstry field of each enemy
* structure.
*
********
         
EDestruct_Normal:                            ; Normal explosion
         move.w   #-10000,e_h(a4)
         cmp.w    #15,e_w(a4)
         bge.s    edl
         move.w   #EXPLODE,(a4)
         move.w   #in_Explosion1,e_image(a4)
         rts

edl:     move.w   #EXPLODE2,(a4)
         move.w   #in_LExplosion1,e_image(a4)
         rts

EDestruct_Solid:                             ; Solid enemy
         moveq    #6,d0
         bsr      random
         add.w    difficulty(a5),d0          ; D0 from diff to diff + 5
         cmp.w    #5,d0
         ble.s    EDestruct_Normal           ; Use normal destruction

         move.w   #EDestruct_Normal-Enemy_Collisions,e_dstry(a4)
         move.w   #SPINNER4M,(a4)
         subq.w   #2,e_h(a4)
         subq.w   #2,e_w(a4)
         move.w   #8,e_dmg(a4)
         move.w   #$101,e_data(a4)
         rts

EDestruct_Boss:
         move.w   #EXPLODE2,(a4)
         move.w   #-10000,e_h(a4)
         move.w   #in_LExplosion1,e_image(a4)

         cmp.w    #18,-e_size(a4)            ; Previous/next superboss part
         bne.s    not_type_18_prev
         addq.w   #8,-e_size+e_image(a4)
         bra.s    boss_explode_done
not_type_18_prev:
         cmp.w    #20,e_size(a4)
         bne.s    boss_explode_done
         addq.w   #8,e_size+e_image(a4)

boss_explode_done:
         rts

