****************************************************************************
****************************************************************************
**                                                                        **
**   Phoenix for Fargo II : Level Loading Routines                        **
**                                                                        **
**   Copyright 1997-2000 by Patrick Davidson.  All Rights Reserved.       **
**                                                                        **
**   This file was last updated May 14, 2000                              **
**                                                                        **
**   For complete copyright information and contact addresses, refer to   **
**   the main source file "PHOENIX.ASM"                                   **
**                                                                        **
****************************************************************************
****************************************************************************

********************************************* LEVEL TABLE
*
* This is the table of levels used to decode level number bytes, as is
* described in 'LEVELS.ASM'.  The LEVEL macro adds one entry to the table
* (as a word offset from the start of the table), sets a symbol of the level
* name to the current level number, then increments the number.
*
********

numlev   set      0

LEVEL    MACRO
         dc.w     \1-Level_Table
\2       set      numlev
numlev   set      numlev+1
         ENDM

Level_Table:
         LEVEL    Game_Finished,LVL_Restart
         LEVEL    Phoenix_Shop,LVL_Shop

         LEVEL    Triangles,LVL_Triangles

         LEVEL    Level_1_Standard,LVL_1A    
         LEVEL    Level_2_Standard,LVL_1B     
         LEVEL    Level_3_Boss,LVL_1C

         LEVEL    Level_4_Standard,LVL_2A
         LEVEL    Level_5_Standard,LVL_2B
         LEVEL    Level_6_Boss,LVL_2C

         LEVEL    Level_4a_Standard,LVL_3A
         LEVEL    Level_5a_Standard,LVL_3B
         LEVEL    Level_6a_Boss,LVL_3C

         LEVEL    Level_7_Standard,LVL_4A
         LEVEL    Level_8_Standard,LVL_4B
         LEVEL    Level_9_Boss,LVL_4C

         LEVEL    Level_10_Standard,LVL_5A
         LEVEL    Level_11_Standard,LVL_5B
         LEVEL    Level_12_2Boss,LVL_5C

         LEVEL    Level_13_Standard,LVL_6A
         LEVEL    Level_14_Standard,LVL_6B
         LEVEL    Level_15_3Boss,LVL_6C

         LEVEL    Level_16_Standard,LVL_7A
         LEVEL    Level_17_Standard,LVL_7B
         LEVEL    Level_18_Boss,LVL_7C

         LEVEL    Level_19_Standard,LVL_8A
         LEVEL    Level_20_Standard,LVL_8B
         LEVEL    Level_21_3Boss,LVL_8C

         LEVEL    Level_25_SuperBoss,LVL_SuperBoss
         LEVEL    Level_25_SuperBoss_Hard,LVL_SuperBoss_Hard
         LEVEL    Level_29_SuperBoss_Plus,LVL_SuperBoss_Plus

         LEVEL    Free_Ship,LVL_Free_Ship

         LEVEL    MWheel_Loop_20,LVL_MWheel20
         LEVEL    MWheel_Loop_15,LVL_MWheel15
         LEVEL    MWheel_Loop_10,LVL_MWheel10
         LEVEL    MWheel_Loop_8,LVL_MWheel8
         LEVEL    Wheel_Loop_16,LVL_Wheel16
         LEVEL    Wheel_Loop_10,LVL_Wheel10
         LEVEL    Wheel_Loop_8,LVL_Wheel8
         LEVEL    Wheel_Loop_5,LVL_Wheel5

         LEVEL    Level_33_RandX,LVL_X1
         LEVEL    Level_34_RandX,LVL_X2
         LEVEL    Level_35_RandX,LVL_X3

         LEVEL    Level_26_Operators,LVL_O
         LEVEL    Level_27_Operators_3Boss,LVL_O3
         LEVEL    Level_28_Operators_5Boss,LVL_O5

******************************************** LEVEL LOADERS
*
* These are the actual level loaders called to initialize each level.  The
* loaders for fake levels (the shop, etc.) are contained in their specific
* files.  Refer to the end of LEVELS.ASM for a description of how these
* loaders are used and what variables they are passed.
*
********

Level_1_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_1(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_2_Standard:
         lea      swing_data_bank,a4
         lea      Enemy_1(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_3_Boss:
         lea      low_data_bank,a4
         lea      Enemy_1(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss1(pc),a0
         moveq    #1,d0
         bra      Load_Enemy_Info

Level_4_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_2(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      Enemy_1(pc),a0
         moveq    #10,d0
         bra      Load_Enemy_Info

Level_5_Standard:
         lea      swing_data_bank,a4
         lea      Enemy_2(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_6_Boss:
         lea      low_data_bank,a4
         lea      Enemy_2(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss1(pc),a0
         moveq    #1,d0
         bra      Load_Enemy_Info

get_enemy_3:
         cmp.w    #3,difficulty(a5)
         bge.s    get_tougher
         lea      Enemy_8(pc),a0
         rts
get_tougher:
         lea      Enemy_9(pc),a0
         rts

Level_4a_Standard:
         lea      standard_data_bank,a4
         bsr.s    get_enemy_3
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      Enemy_1(pc),a0
         moveq    #10,d0
         bra      Load_Enemy_Info

Level_5a_Standard:
         lea      swing_data_bank,a4
         bsr.s    get_enemy_3
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_6a_Boss:
         lea      low_data_bank,a4
         bsr.s    get_enemy_3
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss1(pc),a0
         moveq    #1,d0
         bra      Load_Enemy_Info

Level_7_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_5(pc),a0
         lea      enemies_data(a5),a1
         moveq    #15,d0
         bra      Load_Enemy_Info

Level_8_Standard:
         lea      swing_data_bank_spread,a4
         lea      Enemy_5(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_9_Boss:
         lea      low_data_bank,a4
         lea      Enemy_5(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss1(pc),a0
         moveq    #1,d0
         bra      Load_Enemy_Info

Level_10_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_3(pc),a0
         lea      enemies_data(a5),a1
         moveq    #15,d0
         bra      Load_Enemy_Info

Level_11_Standard:
         lea      swing_data_bank,a4
         lea      Enemy_3(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_12_2Boss:
         lea      low_data_bank,a4
         lea      Enemy_3(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss1(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #1,d0
         bra      Load_Enemy_Info

Level_13_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_4(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      Enemy_3(pc),a0
         moveq    #10,d0
         bra      Load_Enemy_Info

Level_14_Standard:
         lea      swing_data_bank,a4
         lea      Enemy_4(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_15_3Boss:
         lea      low_data_bank,a4
         lea      Enemy_4(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #3,d0
         bsr      Load_Enemy_Info
         move.w   #-210,-e_size+e_data(a1)
         move.w   #-270,-(2*e_size)+e_data(a1)
         rts

Level_16_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_6(pc),a0
         lea      enemies_data(a5),a1                   
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_17_Standard:
         lea      swing_data_bank,a4
         lea      Enemy_6(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_18_Boss:
         lea      multi_data_bank,a4
         lea      Enemy_6(pc),a0
         lea      enemies_data(a5),a1
         moveq    #24,d0
         bsr      Load_Enemy_Info
         lea      E_Boss3(pc),a0
         moveq    #1,d0
         bra      Load_Enemy_Info

Level_19_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_7(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         move.w   #EDestruct_Solid-Enemy_Collisions,d6
         bsr      Load_Enemy_Info
         lea      Enemy_3(pc),a0
         moveq    #10,d0
         move.w   #EDestruct_Normal-Enemy_Collisions,d6
         bra      Load_Enemy_Info

Level_20_Standard:
         lea      swing_data_bank,a4
         lea      Enemy_7(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         move.w   #EDestruct_Solid-Enemy_Collisions,d6
         bra      Load_Enemy_Info

Level_21_3Boss:
         lea      low_data_bank,a4
         lea      Enemy_7(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         move.w   #EDestruct_Solid-Enemy_Collisions,d6
         bsr      Load_Enemy_Info
         move.w   #EDestruct_Normal-Enemy_Collisions,d6
         lea      E_Boss2(pc),a0
         moveq    #3,d0
         bsr      Load_Enemy_Info
         move.w   #-210,-e_size+e_data(a1)
         move.w   #-270,-(2*e_size)+e_data(a1)
         rts

Level_25_SuperBoss_Hard:
         lea      enemies_data(a5),a1
         lea      low_data_bank,a4
         lea      Enemy_9(pc),a0
         moveq    #10,d0
         bsr      Load_Enemy_Info
         bra.s    Level_25_Common
Level_25_SuperBoss:
         lea      enemies_data(a5),a1
Level_25_Common:
         move.w   #EDestruct_Boss-Enemy_Collisions,d6
         lea      E_fake(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupL(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupR(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         subq.w   #1,enemies_remaining(a5)
         rts

Level_26_Operators:
         move.b   #64,smct+1
         lea      Enemy_0(pc),a0
         lea      enemies_data(a5),a1
         moveq    #12,d0
         bra      Load_Enemy_Info

Level_27_Operators_3Boss:
         lea      Enemy_0(pc),a0
         lea      enemies_data(a5),a1
         moveq    #12,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #3,d0
         bsr      Load_Enemy_Info
         move.w   #-180,-e_size+e_data(a1)
         move.w   #-120,-(2*e_size)+e_data(a1)
         rts

Level_28_Operators_5Boss:
         lea      Enemy_0(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #5,d0
         bsr      Load_Enemy_Info
         move.w   #-210,-e_size+e_data(a1)
         move.w   #-240,-(2*e_size)+e_data(a1)
         move.w   #-180,-(3*e_size)+e_data(a1)
         move.w   #-120,-(4*e_size)+e_data(a1)
         rts

Level_29_SuperBoss:
         lea      enemies_data(a5),a1
         lea      E_fake(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupL(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupR(pc),a0
L29_Common:
         moveq    #1,d0
         move.w   #EDestruct_Boss-Enemy_Collisions,d6
         bsr      Load_Enemy_Info
         subq.w   #1,enemies_remaining(a5)
         lea      Enemy_0(pc),a0
         moveq    #22,d0
         bra      Load_Enemy_Info

Level_29_SuperBoss_Plus:
         lea      enemies_data(a5),a1
         lea      E_fake(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupL_(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupR_(pc),a0
         bra.s    L29_Common

Level_33_RandX:
         move.b   #98,smct+1
         lea      E_X(pc),a0
         lea      enemies_data(a5),a1
         moveq    #12,d0
         bra      Load_Enemy_Info

Level_34_RandX:
         lea      E_X(pc),a0
         lea      enemies_data(a5),a1
         moveq    #12,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #3,d0
         bsr      Load_Enemy_Info
         move.w   #-180,-e_size+e_data(a1)
         move.w   #-120,-(2*e_size)+e_data(a1)
         rts

Level_35_RandX:
         lea      E_X(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #5,d0
         bsr      Load_Enemy_Info
         move.w   #-210,-e_size+e_data(a1)
         move.w   #-240,-(2*e_size)+e_data(a1)
         move.w   #-180,-(3*e_size)+e_data(a1)
         move.w   #-120,-(4*e_size)+e_data(a1)
         rts

MWheel_Loop_20:
         moveq    #1,d0
         moveq    #20,d1
         moveq    #18,d2
         moveq    #40,d3
         move.w   #MWHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

MWheel_Loop_15:
         moveq    #1,d0
         moveq    #15,d1
         moveq    #24,d2
         moveq    #40,d3
         move.w   #MWHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

MWheel_Loop_10:
         moveq    #1,d0
         moveq    #10,d1
         moveq    #36,d2
         moveq    #40,d3
         move.w   #MWHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

MWheel_Loop_8:
         moveq    #1,d0
         moveq    #8,d1
         moveq    #45,d2
         moveq    #40,d3
         move.w   #MWHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

Wheel_Loop_16:
         moveq    #1,d0
         moveq    #16,d1
         moveq    #10,d2
         moveq    #40,d3
         moveq    #WHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

Wheel_Loop_10:
         moveq    #1,d0
         moveq    #10,d1
         moveq    #16,d2
         moveq    #40,d3
         moveq    #WHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

Wheel_Loop_8:
         moveq    #1,d0
         moveq    #8,d1
         moveq    #20,d2
         moveq    #40,d3
         moveq    #WHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

Wheel_Loop_5:
         moveq    #1,d0                      ; D0 = time counter
         moveq    #5,d1                      ; D1 = # enemies
         moveq    #32,d2                     ; D2 = staggering amount
         moveq    #40,d3
         moveq    #WHEEL_WAIT,d4

Wheel_Loader_Init:
         lea      enemies_data(a5),a1
         move.w   d1,enemies_remaining(a5)
         subq.w   #1,d1

Wheel_Loader:
         move.w   d4,(a1)+                   ; Initial type
         move.w   d3,(a1)+                   ; Enemy strength
         move.w   #-300,(a1)+                ; Dummy X-coord
         move.w   #15,(a1)+                  ; Width
         move.w   #-300,(A1)+                ; Dummy X-coord
         move.w   #15,(A1)+                  ; Height
         move.w   #in_Wheel_1,(a1)+          ; Image
         move.w   d0,(a1)+                   ; Time counter
         move.w   d6,(a1)+
         add.w    d2,d0                      ; Increment staggering level
         dbra     d1,Wheel_Loader
         rts

Triangles:
         move.w   level_number(a5),d0
         lea      enemies_data(a5),a1
         lea      E_Tri(pc),a0
         
******************************************** LEVEL LOADER SUBROUTINES
*
* This routine is used to install enemies in the enemy array.  It is called
* with the following arguments:
*
* A4 -> Table of coordinates (if any)
* D0 = Number of enemies to install
* D6 = Enemy destruction routine (see EDESTROY.ASM)
* A0 -> Enemy data block
* A1 -> Position in enemy array (should be enemies_data on first call)
*
* This routine will increase the number of enemies remaining by the given
* amount, and install the specified number of enemies at the specified type.
* The main level code will call the level loader with A1 set to enemies_data
* initially so it is usually unnecessary for the level loader to set that.
* Also, D6 is the "normal" destruction routine (for non-bosses) on entry to
* the loader, so it can often be ignored also.
*
* The X and Y coordinates are both set to -300, so enemies must move
* themselves into the screen at an appropriate time.
*
* This routine changes only D0, A1, and A2.
*
********
                                    
Load_Enemy_Info:
         move.l   a4,xy_pointer(a5)
         add.w    d0,enemies_remaining(a5)
         subq.w   #1,d0
_Load_Enemy_Info:
         lea      (a0),a2
         move.w   (a2)+,(a1)+
         move.w   (a2)+,(a1)+
         move.w   #-300,(a1)+
         move.w   (a2)+,(a1)+
         move.w   #-300,(a1)+
         move.w   (a2)+,(a1)+
         move.w   (a2)+,(a1)+
         move.w   (a2)+,(a1)+
         move.w   d6,(A1)+
         dbra     d0,_Load_Enemy_Info
         rts

******************************************** COORDINATE DATA BANKS

standard_data_bank:
         dc.w     70,20,90,20,110,20,130,20,150,20
         dc.w     70,35,90,35,110,35,130,35,150,35
         dc.w     70,50,90,50,110,50,130,50,150,50
         dc.w     70,65,90,65,110,65,130,65,150,65

swing_data_bank:
         dc.w     67,20,87,20,107,20,127,20,147,20
         dc.w     73,35,93,35,113,35,133,35,153,35
         dc.w     67,50,87,50,107,50,127,50,147,50
swing_data_bank_spread:
         dc.w     73,65,93,65,113,65,133,65,153,65
         dc.w     63,20,83,20,103,20,123,20,143,20
         dc.w     73,35,93,35,113,35,133,35,153,35
         dc.w     63,50,83,50,103,50,123,50,143,50

low_data_bank:
         dc.w     70,54,90,54,110,54,130,54,150,54
         dc.w     70,69,90,69,110,69,130,69,150,69      

multi_data_bank:
         dc.w     64,52,76,52,88,52,100,52,112,52,124,52,136,52,148,52
         dc.w     64,61,76,61,88,61,100,61,112,61,124,61,136,61,148,61
         dc.w     64,70,76,70,88,70,100,70,112,70,124,70,136,70,148,70

******************************************** ENEMY DATA BLOCKS

         ;type, strength, width, height, image, data

Enemy_1: dc.w     STANDARD,2,8,7,in_Enemy_1,-1        ; First normal enemy
Enemy_2: dc.w     STANDARD,4,11,8,in_Enemy_2,-1       ; Second norMal enemy
Enemy_3: dc.w     SPINNER1,8,10,10,in_Enemy3_1,-1     ; Spinning enemy
Enemy_4: dc.w     SPINNER2,12,10,10,in_Enemy4_1,-1    ; Tough spinning enemy
Enemy_5: dc.w     ARROW,6,7,13,in_Enemy_5,-1          ; Tall arrowing enemy
Enemy_6: dc.w     CROSS,16,7,7,in_Enemy_6,-1          ; First X enemy
Enemy_7: dc.w     SPINNER3,20,10,10,in_Enemy7_1,-1    ; Solid spinning enemy
Enemy_8: dc.w     STANDARD,6,6,5,in_Enemy_8,-1        ; Third normal enemy
Enemy_9: dc.w     MODIFIED,6,6,5,in_Enemy_8,-1        ; Third enemy (MkII)
Enemy_0: dc.w     OPERATOR_LOCATING,30,7,7,in_Enemy_0_5,-1

E_Tri:   dc.w     TRIANGLE,16,13,11,in_Triangle,$101
E_X:     dc.w     RANDOM_X,24,9,7,in_E_X,$101

E_Boss1: dc.w     BOSS,40,17,14,in_Boss_1,-90         ; Standard boss
E_Boss2: dc.w     BOSS,50,17,14,in_Boss_2,-150        ; Second (fuzzy center) boss
E_Boss3: dc.w     BOSS,100,17,9,in_Boss_X,-100        ; Double-X Boss

E_SupL:  dc.w     SUPERBOSS_L,150,17,11,in_SuperBoss_Left,-5
E_SupR:  dc.w     SUPERBOSS_R,150,17,11,in_SuperBoss_Right,-5
E_SupL_: dc.w     SUPERBOSS_L,250,17,15,in_SuperBoss_Left_,-5
E_SupR_: dc.w     SUPERBOSS_R,250,17,15,in_SuperBoss_Right_,-5

E_fake:  dc.w     FAKE1,32767,34,-10,in_fake,-5 ; Fake enemy for attaching
