****************************************************************************
****************************************************************************
**                                                                        **
**   Phoenix for TI-89, TI-92, and TI-92 Plus : Title Screen Routines     **
**                                                                        **
**   Copyright 1997-2000 by Patrick Davidson.  All Rights Reserved.       **
**                                                                        **
**   This file was last updated May 14, 2000                              **
**                                                                        **
**   For complete copyright information and contact addresses, refer to   **
**   the main source file "PHOENIX.ASM"                                   **
**                                                                        **
****************************************************************************
****************************************************************************

******************************************** INITIALIZE TITLE SCREEN

Phoenix_Title_Screen:
      IFND ti89d
         bsr      Status_Prepare
         moveq    #1,d0                      ; Set font to large
         bsr      Set_Font
         bsr      Display_Screen
         lea      Main_Title_Messages(pc),a2
         moveq    #3,d3
         moveq    #2,d4
         moveq    #56,d5
         bsr      Print_Messages
         moveq    #4,d3
         addq.w   #3,d4
         bsr      Print_Messages
         moveq    #4,d3
         addq.w   #3,d4
         bsr      Print_Messages
      ENDIF

      IFD ti89d
         moveq    #0,d0                      ; Set font to small
         bsr      Set_Font
         bsr      Clear_Screen
         lea      Main_Title_Messages(pc),a2
         moveq    #10,d3
         moveq    #2,d4
         bsr      Print_Messages
         move.w   #$d1,speed(a5)
      ENDIF
         
******************************************** TITLE SCREEN LOOP

Title_Loop:
         bsr      Test_Key
         cmp.w    #264,d0
         beq      Game_Over
         cmp.w    #268,d0
         beq.s    Start_Actual_Game
         cmp.w    #"I",d0
         bne.s    noinv
         st       inv(a5)
noinv:   cmp.w    #269,d0
      IFND ti89d
         beq.s    Start_Actual_Game
         cmp.w    #270,d0
         beq.s    Start_Actual_Game
         cmp.w    #271,d0
         beq.s    Start_Actual_Game
         cmp.w    #272,d0
         beq.s    Show_Copyright
         cmp.w    #273,d0
         beq.s    Show_Contact
         cmp.w    #274,d0
         beq.s    Show_Instructions
         cmp.w    #275,d0
      ENDIF
      IFD ti89d
         beq      Show_Copyright
         cmp.w    #270,d0
         beq      Show_Contact
         cmp.w    #271,d0
         beq      Show_Instructions
         cmp.w    #272,d0
      ENDIF
         beq      Show_High_Scores
      IFND ti89d
         bsr      Scroll_Side                ; Scroll sides of screen
         bsr      Display_Screen_Sides       ; Display sides of screen
      ENDIF
         bsr      Timer_Delay                ; Wait for next 30th of second
         bra.s    Title_Loop                 ; Stay on title if not pressed 

Start_Actual_Game:
      IFD ti89d
         bsr      Clear_Screen
         lea      Select_Diff_Message(pc),a2
         moveq    #5,d3
         moveq    #1,d4
         bsr      Print_Messages
SDL:     bsr      Get_Key
         cmp.w    #264,d0
         beq      Game_Over
         sub.w    #268,d0
         move.w   d0,d1
         and.w    #$FFFC,d1
         bne.s    SDL
         addq.w   #1,d0       
         move.w   d0,difficulty(a5)

         bsr      Clear_Screen
         lea      Select_Speed_Message(PC),a1
         moveq    #3,d3
         moveq    #1,d4
         bsr      Print_Messages
SSL:     bsr      Get_Key
         cmp.w    #264,d0
         beq      Game_Over
         cmp.w    #268,d0
         beq.s    Game_Normal
         cmp.w    #269,d0
         beq.s    Game_Fast
         bra.s    SSL

Game_Normal:
         bsr      Status_Prepare
         st       Game_Started(a5)
         rts

Game_Fast:
         move.w   #$e1,speed(a5)
         bra.s    Game_Normal
      ENDIF

      IFND ti89d
         sub.w    #267,d0
         move.w   d0,difficulty(a5)
         bsr      Status_Prepare
         st       Game_Started(a5)
         rts
      ENDIF

Show_Copyright:
         lea      Copyright_Messages(pc),a2
         bra.s    Display_Page

Show_Contact:
         lea      Contact_Messages(pc),a2
         bra.s    Display_Page

Show_Instructions:
         lea      Instruction_Messages(pc),a2

Display_Page:
      IFND ti89d
         bsr      Display_Screen
         moveq    #14,d3
         moveq    #1,d4
         moveq    #34,d5
         bsr.s    Print_Messages
         bsr      Status_Prepare
ts_wait_enter:
         bsr      Scroll_Side                ; Scroll sides of screen
         bsr      Display_Screen_Sides       ; Display sides of screen
         bsr      Timer_Delay                ; Wait for next 30th of second
         bsr      Test_Key
         cmp.w    #264,d0
         beq      Game_Over
         cmp.w    #32,d0
      ENDIF

      IFD ti89d
         bsr      Clear_Screen
         moveq    #14,d3
         moveq    #1,d4
         bsr.s    Print_Messages
         bsr      Status_Prepare
ts_wait_enter:
         bsr      Timer_Delay                ; Wait for next 30th of second
         bsr      Test_Key
         cmp.w    #264,d0
         beq      Game_Over
         cmp.w    #13,d0
      ENDIF

         bne.s    ts_wait_enter
         bra      Phoenix_Title_Screen

Show_High_Scores:
         bsr      Display_High_Scores
         bra      Phoenix_Title_Screen

******************************************** DISPLAY A SEQUENCE OF MESSAGES

Print_Messages:
      IFND ti89d
         move.w   d5,d1
         move.w   d4,d0
         addq.w   #8,d4
      ENDIF
      IFD ti89d
         moveq    #0,d1
         move.w   d4,d0
         addq.w   #6,d4
      ENDIF
         lea      (a2),a0
         bsr      Display_String
loop_end_str:
         tst.b    (a2)+
         bne.s    loop_end_str
         dbra     d3,Print_Messages
         rts

******************************************** TITLE SCREEN MESSAGES

      IFND ti89d
Main_Title_Messages:
         dc.b     '    POLUX 1.46',0
         dc.b     'Copyright (c) 2000',0
         dc.b     'par Gab Corporation',0
         dc.b     'Tous Droits Reserves',0

Starting_Title_Messages:
         dc.b     ' Starting the Game',0
         dc.b     'F1 - Beginner',0
         dc.b     'F2 - Intermediate',0
         dc.b     'F3 - Advanced',0
         dc.b     'F4 - Expert',0

Info_Title_Messages:
         dc.b     '  Additional Info',0
         dc.b     'F5 - Copyright Info',0
         dc.b     'F6 - Contact Addrs.',0
         dc.b     'F7 - Instructions',0
         dc.b     'F8 - High Scores',0
      ENDIF

      IFD ti89d
Select_Diff_Message:
         dc.b     'Choisis ton niveau :',0
         dc.b     0
         dc.b     'F1 - Gros mauvais',0
         dc.b     'F2 - Bon',0
         dc.b     'F3 - Tres bon',0
         dc.b     'F4 - TRES-TRES BON !',0

Select_Speed_Message:
         dc.b     'Choisis le mode :',0
         dc.b     0
         dc.b     'F1 - Normal',0
         dc.b     'F2 - Rapide',0
        
Main_Title_Messages:
         dc.b     '    POLUX 1.46',0
         dc.b     'Copyright (c) 2000',0
         dc.b     'Modification de Gaby H !',0
         dc.b     'Tous Droits Reserves',0
         dc.b     'Merci a Patrick Davidson',0
         dc.b     0
         dc.b     'F1 - Nouvelle Mission',0   
         dc.b     'F2 - Infos Copyright',0
         dc.b     'F3 - Contactez-moi !',0
         dc.b     'F4 - Instructions',0
         dc.b     'F5 - Meilleurs Scores',0
      ENDIF

Copyright_Messages:
         dc.b     '         Ce jeu est :',0
         dc.b     '   Copyright (c) 2000',0
         dc.b     '   par Patrick Davidson',0
         dc.b     0
         dc.b     '   Ce jeu peut etre joue',0
         dc.b     'et copie librement dans sa',0
         dc.b     'forme originale. Vous pouvez',0
         dc.b     'par contre distribuer d autres',0
         dc.b     'versions avec certaines',0
         dc.b     'conditions.  Telechargez le',0
         dc.b     'jeu Phoenix complet',0
         dc.b     'pour les informations a',0
         dc.b     'propos des conditions ...',0
         dc.b     0
      IFND ti89d
         dc.b     'Press [SPACE] to return...',0
      ENDIF
      IFD ti89d
         dc.b     'Presses [ENTER] gros naze ...',0
      ENDIF

Instruction_Messages:
         dc.b     'POLUX In-Game Controles:',0
         dc.b     'Fleches - bouger ta caisse',0
      IFND ti89
         dc.b     'LOCK - fires weapon',0
         dc.b     'F1 thru F8 - select weapon',0
         dc.b     'APPS - Save game and exit',0
         dc.b     'MODE + ESC - Exit the game',0
         dc.b     'SPACE - Special weapon',0
      ENDIF
      IFD ti89
         dc.b     '2ND - Tirer comme un bourrin',0
         dc.b     '1->8 - Choisir Arme',0
         dc.b     'APPS - Eteindre la calculette',0
         dc.b     '. (POINT) - Se casser du jeu',0
         dc.b     'Diamant - Arme speciale',0
      ENDIF
         dc.b     0
         dc.b     'La sante de ta pauv caisse',0
         dc.b     'est indiquee par la barre en',0
         dc.b     'bas de l ecran de jeu .',0
         dc.b     'Elle diminue quand tu te',0
         dc.b     'fais exploser la gueule.',0
         dc.b     0
      IFND ti89d
         dc.b     'Press [SPACE] to return...',0
      ENDIF
      IFD ti89d
         dc.b     'Presses [ENTER] ducon ...',0
      ENDIF

Contact_Messages:
         dc.b     'Web:  http://pad.calc.org/',0
         dc.b     'E-Mail : Gaby_la_star@hotmail.com',0
         dc.b	     'Patrick Davidson : Pad@calc.org',0
         dc.b     0
         dc.b     'Tous les joueurs de POLUX',0
         dc.b     'peuvent E-Mailer leurs idees,',0
         dc.b     'commentaires, ou dire les bugs',0
         dc.b     'du jeu.  Dites-moi la',0
         dc.b     'version du jeu POLUX',0
         dc.b     'et quelle calculatrice',0
         dc.b     'vous avez. Si vous trouvez',0
         dc.b     'un bug, decrivez-moi',0
         dc.b     'en detail ce que vous avez',0
         dc.b     'fait avant que l erreur arrive...',0
         dc.b     0
      IFND ti89d
         dc.b     'Press [SPACE] to return...',0
      ENDIF
      IFD ti89d
         dc.b     'Presses [ENTER] tete de...',0
      ENDIF

******************************************** PROGRAM TITLE

_comment:
         dc.b     'POLUX 1.46 par Gaby H.',0

      IFND ti89d
_full_title:
         dc.b     'POLUX 1.46 par Gaby H.',0
         dc.b     'Copyright 1997-2000 by Patrick Davidson',0
      ENDIF

         CNOP     0,2
